# Changelog

## v0.19.0

Implemented enhancements:

- Add block-level `sphinx_gallery_capture_repr_block` setting #1398 (tpvasconcelos)

Fixed bugs:

- Fix minigallery duplicates and add tests and update documenation #1435 (lucyleeow)

- Fix: Fix minigallery duplicates #1430 (lucyleeow)

- Fix incorrect paths for JupyterLite Notebook interface URLs, unpin `jupyterlite-sphinx`, and update JupyterLite integration docs #1417 (agriyakhetarpal)

- BUG: make _anim_rst windows compatible #1399 (story645)

- Fix custom sort #1391 (drammock)

Documentation

- DOC Fixes to minigallery doc in `configuration\.rst` #1437 (lucyleeow)

- DOC Improve doc on linking code blocks #1419 (lucyleeow)

- Doc: mention color css property to hide links #1412 (jschueller)

- DOC Improve custom sort key docs #1401 (lucyleeow)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1434 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1431 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1428 (pre-commit-ci[bot])

- Fix label checker workflow #1426 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1423 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1422 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1418 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1416 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1415 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1413 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1408 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1407 (pre-commit-ci[bot])

- Bump codecov/codecov-action from 4 to 5 in the actions group #1406 (dependabot[bot])

- [pre-commit.ci] pre-commit autoupdate #1405 (pre-commit-ci[bot])

- MNT Add test for `minigallery_sort_order` #1402 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1400 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1395 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1393 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1390 (pre-commit-ci[bot])

## v0.18.0

Implemented enhancements:

- Allow to disable writing computation times #1385 (bmwiedemann)

- [ENH] Add option to render multiple images from same cell as single-img #1384 (tsbinns)

Fixed bugs:

- Fix `indexst` variable does not exist when own index gallery is first #1383 (lucyleeow)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1387 (pre-commit-ci[bot])

- Bump mamba-org/setup-micromamba from 1 to 2 in the actions group #1386 (dependabot[bot])

- [pre-commit.ci] pre-commit autoupdate #1380 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1379 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1378 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1377 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1376 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1375 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1373 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1372 (pre-commit-ci[bot])

## v0.17.1

Fixed bugs:

- FIX: Fix stability of stored compiled regex #1369 (larsoner)

- ENH: Improve _sanitize_rst #1366 (timhoffm)

- Obey prefer_full_module setting when finding backreferences #1364 (QuLogic)

- Fix linking to class attributes with prefer_full_module #1363 (QuLogic)

- Improve minigallery directive path input resolution #1360 (lucyleeow)

- FIX Allow str path minigallery entries when backreferences off #1355 (lucyleeow)

- FIX generate zipfiles when index passed by user #1353 (lucyleeow)

Documentation

- DOC Improve doc about joblib warnings #1367 (lucyleeow)

- DOC add note on filtering joblib warnings #1362 (lucyleeow)

- DOC Minor update to minigallery directive doc #1358 (lucyleeow)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1368 (pre-commit-ci[bot])

- MNT Change mark and fixture names for adding files #1365 (lucyleeow)

- MNT Add warning when ‘examples_dirs’ and ‘gallery_dirs’ unequal lengths #1361 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1357 (pre-commit-ci[bot])

- Update pyvista in doc CI #1352 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1351 (pre-commit-ci[bot])

- MNT Bump version #1350 (lucyleeow)

## v0.17.0

Support for Python 3.8 and Sphinx 4 dropped in this release. Requirement is now Python >= 3.9 and Sphinx >= 5.

Implemented enhancements:

- Introduction tooltip corresponds to the first paragraph #1344 (fgmacedo)

- FIX Jupyterlite in CircleCI artifact #1336 (lesteve)

- MNT: Rename README.rst to GALLERY_HEADER.rst #1321 (timhoffm)

- [ENH] Add custom thumbnails for failing examples #1313 (tsbinns)

- ENH integrate download/launcher links into `pydata-sphinx-theme` secondary sidebar #1312 (Charlie-XIAO)

- add option for zip downloads #1299 (jamiecook)

- Allow setting animation format from gallery config #1243 (QuLogic)

Fixed bugs:

- Fix handling of multi-module intersphinx registries #1320 (QuLogic)

- BUG: Fix bug with traceback with SyntaxError #1301 (larsoner)

Documentation

- DOC Add napari to users #1346 (lucyleeow)

- DOC Fix nested_sections #1339 (lucyleeow)

- DOC Improve `nested_sections` #1326 (lucyleeow)

- DOC: Remove definition lists from contribution guide #1318 (QuLogic)

- MNT: fixed documentation links in the readme #1310 (story645)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1348 (pre-commit-ci[bot])

- MNT: Fix `gallery_conf` changes do not need to be returned #1347 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1345 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1342 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1338 (pre-commit-ci[bot])

- MNT: Sort imports and add to pre commit #1337 (lucyleeow)

- MNT: Refactor `generate_file_rst` #1335 (lucyleeow)

- MNT: Refactor `_fill_gallery_conf_defaults` #1334 (lucyleeow)

- MNT Use `os.sep` everywhere #1333 (lucyleeow)

- MNT: Refactor `generate_dir_rst` and `generate_gallery_rst` #1332 (lucyleeow)

- MNT: Add ipython to dev dependencies #1329 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1328 (pre-commit-ci[bot])

- Fix make file clean in tinybuild #1327 (lucyleeow)

- Bump the actions group with 5 updates #1325 (dependabot[bot])

- [pre-commit.ci] pre-commit autoupdate #1324 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1319 (pre-commit-ci[bot])

- Include dev dependencies in pyproject.toml and update docs on requirements #1317 (AlexSzatmary)

- [pre-commit.ci] pre-commit autoupdate #1314 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1311 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1307 (pre-commit-ci[bot])

- MAINT Add `sphinxcontrib-video` to dev requirements #1305 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1304 (pre-commit-ci[bot])

- MNT: Turn the block tuple into a namedtuple #1303 (timhoffm)

- [pre-commit.ci] pre-commit autoupdate #1300 (pre-commit-ci[bot])

- lint: define codespell in `pyproject.toml` #1298 (Borda)

- MAINT Bump version 0.17 #1297 (lucyleeow)

## v0.16.0

Sphinx 7.3.0 and above changed caching and serialization checks. Now instead of passing instantiated classes like `ResetArgv()`, classes like `FileNameSortKey`, or callables like `notebook_modification_function` in `sphinx_gallery_conf`, you should pass fully qualified name strings to classes or callables. If you change to using name strings, you can simply use a function as the use of classes to ensure a stable `__repr__` would be redundant.

See Importing callables for details.

Implemented enhancements:

- ENH: Allow plain list as subsection_order and support a wildcard #1295 (timhoffm)

- [ENH] Minigallery can take arbitrary files/glob patterns as input #1226 (story645)

Fixed bugs:

- BUG: Fix serialization with Sphinx 7.3 #1289 (larsoner)

- ENH: minigallery_sort_order on full path #1253 (story645)

- BUG: `UnicodeDecodeError` in recommender #1244 (Charlie-XIAO)

Documentation

- DOC Update FFMpeg note in conf animation docs #1292 (lucyleeow)

- readme: adding quickstart section #1291 (Borda)

- readme: add link to docs #1288 (Borda)

- DOC Clarify sub level example gallery #1281 (lucyleeow)

- DOC Mention `image_srcset` config in scraper section in `advanced.rst` #1280 (lucyleeow)

- BUG: Fix errors in example usage of ignore_repr_types and reset_argv #1275 (speth)

- DOC Use ‘nested_sections’ `True` for docs #1263 (lucyleeow)

- fix: Missing full stop in download message #1255 (AlejandroFernandezLuces)

- Add HyperSpy and kikuchipy to ‘who uses’ #1247 (jlaehne)

- DOC: Fix formatting in contribute.rst #1237 (StefRe)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1294 (pre-commit-ci[bot])

- Fix typo in `test_fileno` #1287 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1284 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1279 (pre-commit-ci[bot])

- Remove leftover config checking of `image_srcset` #1278 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1277 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1273 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1272 (pre-commit-ci[bot])

- More informative title for ‘check label’ CI workflow #1271 (lucyleeow)

- pyproject: cleaning pytest config #1269 (Borda)

- allow call script as pkg entry #1268 (Borda)

- refactor: migrate to `pyproject.toml` #1267 (Borda)

- lint: enable `sphinx-lint` for Sphinx extension #1266 (Borda)

- ci: associate `install.sh` with used job #1265 (Borda)

- lint: switch from Black to Ruff’s “Black” #1264 (Borda)

- [pre-commit.ci] pre-commit autoupdate #1260 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1257 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1256 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1252 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1251 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1249 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1248 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1246 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1245 (pre-commit-ci[bot])

- Fix AST deprecation warnings #1242 (QuLogic)

- Simplify Matplotlib scraper #1241 (QuLogic)

- [pre-commit.ci] pre-commit autoupdate #1239 (pre-commit-ci[bot])

- MAINT: Fix deployment #1236 (larsoner)

- MAINT Bump version and update `maintainers.rst` #1234 (lucyleeow)

## v0.15.0

Support for Python 3.7 dropped in this release. Requirement is now Python >=3.8. Pillow added as a dependency.

Implemented enhancements:

- ENH: Improve logging visibility of errors and filenames #1225 (larsoner)

- ENH: Improve API usage graph #1203 (larsoner)

- ENH: Always write sg_execution_times and make DataTable #1198 (larsoner)

- ENH: Write all computation times #1197 (larsoner)

- ENH: Support source files in any language #1192 (speth)

- FEA Add examples recommender system #1125 (ArturoAmorQ)

Fixed bugs:

- FIX Copy JupyterLite contents early so it runs before jupyterlite_sphinx build-finished #1213 (lesteve)

- BUG: Fix bug with orphan sg_api_usage #1207 (larsoner)

- MAINT Fix check for mismatched “ignore” blocks #1193 (speth)

- Avoid importing new modules in backrefs #1177 (aganders3)

Documentation

- DOC Put configuration list under headings #1230 (lucyleeow)

- DOC: contributing guide #1223 (story645)

- DOC Note support for python 3.7 dropped in release notes #1199 (lucyleeow)

Project maintenance

- [pre-commit.ci] pre-commit autoupdate #1231 (pre-commit-ci[bot])

- MAINT Add `extras_require` in `setup.py` #1229 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1227 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1224 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1219 (pre-commit-ci[bot])

- MAINT: pydata-sphinx-theme #1218 (larsoner)

- MAINT: Improve CircleCI time #1216 (larsoner)

- [pre-commit.ci] pre-commit autoupdate #1215 (pre-commit-ci[bot])

- MAINT: Move to GHA #1214 (larsoner)

- [pre-commit.ci] pre-commit autoupdate #1206 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1201 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1196 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1194 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1191 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1189 (pre-commit-ci[bot])

- [pre-commit.ci] pre-commit autoupdate #1187 (pre-commit-ci[bot])

- MAINT: Bump ver #1185 (larsoner)

## v0.14.0

Implemented enhancements:

- MAINT Update backreferences docs and add tests #1154 (lucyleeow)

- Remove extra spaces in reported running time #1147 (stefanv)

Fixed bugs:

- MAINT: Fix for Sphinx 7.2 #1176 (larsoner)

- updated mpl gui warning catcher to new error message #1160 (story645)

- Ensure consistent encoding for md5sum generation #1159 (sdhiscocks)

- Maint: Fix `app.builder.outdir` as Sphinx now using pathlib #1155 (lucyleeow)

- Make _LoggingTee compatible with TextIO #1151 (o-laurent)

- MAINT: Replace build_sphinx with sphinx-build #1139 (oscargus)

- Set table.dataframe width to auto in CSS file close #1128 #1137 (photoniker)

Documentation

- DOC Fix typo in `_get_docstring_and_rest` docstring #1182 (lucyleeow)

- DOC Fix Jupyterlite config example in `configuration.rst` #1181 (lucyleeow)

- DOC Update basics gallery name #1153 (lucyleeow)

- DOC: Add link to sphinxcontrib-svg2pdfconverter #1145 (oscargus)

- MNT: Add a few badges #1143 (oscargus)

- MAINT: Fix Zenodo reference #1140 (oscargus)

- Add OpenTURNS to “who uses” list #1133 (jschueller)

- Correctly hide download buttons #1131 (timhoffm)

Project maintenance

- MAINT: Force PRs to be labeled properly #1183 (larsoner)

- MAINT Add to `test_identify_names` so class property tested #1180 (lucyleeow)

- MAINT Lint - fix ast node type in docstrings #1179 (lucyleeow)

- MAINT Move `figure_rst` path testing to own unit test #1173 (lucyleeow)

- MAINT Remove unused parametrize in `test_figure_rst_srcset` #1172 (lucyleeow)

- MAINT Parametrize notebook first/last cell test #1171 (lucyleeow)

- MAINT Lint api usage #1170 (lucyleeow)

- MAINT Fix lint, clean and expand docstrings #1169 (lucyleeow)

- [pre-commit.ci] pre-commit autoupdate #1167 (pre-commit-ci[bot])

- MAINT: yamllint #1166 (larsoner)

- ENH: Use pre-commit #1165 (larsoner)

- MAINT: black . #1164 (larsoner)

- MAINT: Make outdated check better #1161 (larsoner)

- Use pathlib for url `_embed_code_links` #1157 (lucyleeow)

- MAINT: Speed up conda solving #1156 (larsoner)

- MNT: Change % formatting to f-strings #1135 (StefRe)

- MAINT: Update deps and intersphinx links #1132 (larsoner)

## v0.13.0

Implemented enhancements:

- ENH: Create backreferences for default roles #1122 (StefRe)

- ENH raise error in check_jupyterlite_conf with unknown key #1119 (lesteve)

- ENH Add functionality to modify Jupyterlite notebooks based on their content #1113 (lesteve)

- ENH: Add support for WebP #1111 (StefRe)

Fixed bugs:

- ENH Clean-up code by early initialization of sphinx_gallery_conf #1120 (lesteve)

- FIX JupyterLite button links #1115 (lesteve)

- Fix thumbnail text formatting #1108 (StefRe)

- Fix JupyterLite URL with nested gallery folders #1105 (lesteve)

- Avoid potentially changing the matplotlib backend when scraping #1102 (ayshih)

- Remove default ‘%matplotlib inline’ line #1099 (ArturoAmorQ)

- FIX: Only ANSI sanitize non-HTML output #1097 (sdhiscocks)

- BUG: Fix bug with show_api_usage #1095 (larsoner)

- FIX: Add blank line at end of table of contents block #1094 (sdhiscocks)

API changes

- API: Remove deprecated mayavi support #1090 (larsoner)

Documentation

- Add reference to qtgallery (Qt scraper) #1126 (aganders3)

- DOC: Unify abbreviations of reStructuredText #1118 (StefRe)

- Add PyGMT to list “Who uses Sphinx-Gallery” #1114 (yvonnefroehlich)

- DOC Update JupyterLite doc after JupyterLite 0.1.0b19 release #1106 (lesteve)

- Fix project list #1101 (StefRe)

- DOC: Document changes #1098 (larsoner)

- DOC: Document point release changes #1096 (larsoner)

Project maintenance

- MAINT: Use non-aliased status_iterator #1124 (larsoner)

- CLN Clean up naming of early config validation #1123 (lesteve)

- MNT: Remove Python 2 leftovers #1116 (StefRe)

- MNT: Sync minimum sphinx version with README.rst #1110 (StefRe)

- CI Install jupyterlite-pyodide-kernel in CI #1107 (lesteve)

- Add test for setting a non-agg Matplotlib backend #1104 (ayshih)

- MAINT: Bump version to dev #1089 (larsoner)

## v0.12.2

Fixed bugs:

- FIX: Only ANSI sanitize non-HTML output #1097 (sdhiscocks)

## v0.12.1

Fixed bugs:

- BUG: Fix bug with show_api_usage #1095 (larsoner)

- FIX: Add blank line at end of table of contents block #1094 (sdhiscocks)

## v0.12.0

Support for Sphinx < 4 dropped in this release. Requirement is Sphinx >= 4.

Implemented enhancements:

- ENH: allow rst files to pass through #1071 (jklymak)

- Update advanced usage examples #1045 (HealthyPear)

- Use descriptive link text for example page header #1040 (betatim)

- Expose `sphinx_gallery_conf` in `python_to_jupyter_cli` #1027 (OverLordGoldDragon)

- DOC: fix ‘Who uses Sphinx-Gallery’ list #1015 (StefRe)

- [MAINT, MRG] A few small leftovers from API usage #997 (alexrockhill)

- [ENH, MRG] Make orphan of unused API entries #983 (alexrockhill)

- Jupyterlite integration #977 (amueller)

Fixed bugs:

- MNT: fix subfolder README detection #1086 (jklymak)

- API: Deprecate mayavi scraper #1083 (larsoner)

- FIX: indentation fix #1077 (jklymak)

- Adds `plot_gallery` as a string by default #1062 (melissawm)

- Fix broken links when using dirhtml builder #1060 (mgoulao)

- BUG: Remove ignore blocks when remove_config_comments=True #1059 (guberti)

- Fixed a bug where backslashes in paths could show up in reST files #1047 (ayshih)

- Allow 2 decimal places in srcset #1039 (OverLordGoldDragon)

- Fix “`subsection_index_toctree` referenced before assignment” #1035 (OverLordGoldDragon)

- [BUG, MRG] fix issue with api usage dict #1033 (alexrockhill)

- MAINT: Remove lingering ref #1022 (larsoner)

- MNT: Fix erroneous commit c6ed4e #1021 (StefRe)

- MNT: make “clean” behave the same on Windows as on Linux #1020 (StefRe)

- DOC Fix typo in scraper doc #1018 (lucyleeow)

- Fix outdated import #1016 (OverLordGoldDragon)

- FIX: role names #1012 (StefRe)

- Bugfix thumbnail text formatting #1005 (alexisthual)

- [MAINT, MRG] Add unused option for API usage, set as default #1001 (alexrockhill)

- FIX: No orphan #1000 (larsoner)

- BUG: Short circuit when disabled #999 (larsoner)

Documentation

- DOC: Add note for html-noplot to suppress config warning. #1084 (rossbar)

- Reorder paragraphs in the minigallery documentation #1048 (ayshih)

- DOC: Switch to pydata-sphinx-theme #1013 (larsoner)

- Fix sphinx link typo in CHANGES #996 (alexisthual)

Project maintenance

- MAINT: Fix CIs #1074 (larsoner)

- TST: gallery inventory/re-structure tinybuild #1072 (jklymak)

- MAINT: Rotate CircleCI key #1064 (larsoner)

- MAINT: Update CIs #1061 (larsoner)

- BUG: Fix full check #1053 (larsoner)

- MAINT: Work around IPython lexer bug #1052 (larsoner)

- MAINT: Fix CIs #1046 (larsoner)

- MAINT: Check CI status #1028 (larsoner)

- MNT: Fix required sphinx version #1019 (StefRe)

- BUG: Update for matplotlib #1010 (larsoner)

- MAINT: Bump to dev #995 (larsoner)

## v0.11.1

Support for Sphinx < 3 dropped in this release. Requirement is Sphinx >= 3.

Fixed bugs:

- BUG: Fix single column example #993 (larsoner)

Implemented enhancements:

- Use Mock more in tests #986 (QuLogic)

- Remove old sphinx compatibility code #985 (QuLogic)

## v0.11.0

In this version, the “Out:” prefix applied to code outputs is now created from CSS pseudo-elements instead of additional real text. For more details, see #896.

Implemented enhancements:

Nesting gallery sections (i.e. gallery subfolders) was implemented in #904. This feature can be disabled (see config option `nested_sections` in the documentation) if the previous behaviour is prefered (alexisthual)

Tooltips now overlay gallery items commit 36166cd. Custom CSS might need to be adapted (alexisthual).

- Problem in section and example title level in subgalleries #935

- Add ability to write nested `index.rst` #855

- Optional usage of `module` instead of `module_short` when doing backreferencing #950 (ExtremOPS)

- ENH: Better dark mode support #948 (larsoner)

- Store API reference examples thumbnails in common div #946 (alexisthual)

- Add flag to ignore code blocks in Python source parser #941 (guberti)

- Improve Jupyter notebook converter’s handling of code blocks #940 (guberti)

- [MRG] Changelog regarding nested sections #926 (alexisthual)

- Possibility to exclude implicit backreferences #908 (StefRe)

- [MRG] Handle nested structures #904 (alexisthual)

- Use pseudo-elements for ‘Out:’ prefixing #896 (QuLogic)

- FIX: Fix for latest pytest #894 (larsoner)

- Config capture_repr on file-by-file basis #891 (StefRe)

Fixed bugs:

We now display gallery items using CSS grid instead of `float` property #906, see migration guide to adapt custom CSS for thumbnails (alexisthual)

- BUG: Hotfix for docopts_url #980 (larsoner)

- BUG: Fix bug with clicking examples #973 (larsoner)

- Remove test examples for seaborn warning #971 (lesteve)

- Fix typo #970 (tkoyama010)

- Avoid matplotlib warnings in seaborn reset_module #969 (lesteve)

- Fix Tensorflow/Abseil compatibility #961 (guberti)

- syntax error fix in sphinx_gallery.downloads #951 (photoniker)

- Merge toctrees containing subcategories indices and examples without … #944 (alexisthual)

- Fix rendering of embedded URIs in Python notebooks #943 (guberti)

- FIX: Fix for dep #938 (larsoner)

- Fix typos #934 (kianmeng)

- MAINT: Fix CIs #932 (larsoner)

- MAINT: Use -nWT –keep-going on Azure #924 (larsoner)

- Ensures right builder conifg #922 (ExtremOPS)

- MAINT: Fix CIs #920 (larsoner)

- MAINT: Clean up namespace #917 (larsoner)

- FIX: Azure #915 (larsoner)

- [WIP] Bugfix missing parent div for mini gallery #914 (alexisthual)

- Honor show_signature #909 (jschueller)

- Css grid for thumbnails #906 (alexisthual)

- Fix matplotlib intersphinx url #902 (StefRe)

- FIX: Pin pyvista #901 (larsoner)

- Fix matplotlib resetter _reset_matplotlib #890 (StefRe)

- Fix “Out” layout for pydata-sphinx-theme #886 (timhoffm)

Documentation updates

- added RADIS in Who uses Sphinx-gallery ? #979 (erwanp)

- add Tonic to list of sphinx-gallery users #972 (biphasic)

- Add Apache TVM to user projects list #942 (guberti)

- DOC: fix rst link syntax in changelog #925 (GaelVaroquaux)

- add GitHub URL for PyPi #923 (andriyor)

- Add Biotite to list of user projects #919 (padix-key)

- MAINT: Remove LooseVersion #916 (larsoner)

- DOC Fix example “Identifying function names in a script” #903 (StefRe)

- DOC Update docs for Adding mini-galleries for API documentation #899 (StefRe)

- Add PyVista examples! #888 (banesullivan)

- Fix a few links in project lists #883 (ixjlyons)

## v0.10.1

Support for Python 3.6 dropped in this release. Requirement is Python >=3.7.

Implemented enhancements:

- Feature Request: `reset_modules` to be applied after each or all examples #866

- Enable `reset_modules` to run either before or after examples, or both #870 (MatthewFlamm)

Fixed bugs:

- embed_code_links throwing <exception: list indices must be integers or slices, not str> #879

- `0.10.0` breaks `sphinx_gallery.load_style` #878

- Add imagesg directive in load style #880 (lucyleeow)

- Use bools for ‘plot_gallery’ in sphinx_gallery_conf #863 (timhoffm)

Merged pull requests:

- DOC Add reference to sphinx-codeautolink #874 (felix-hilden)

- Add Neuraxle to “Who uses Sphinx-Gallery” #873 (guillaume-chevalier)

- DOC Fix typo in dummy images doc #871 (lucyleeow)

- CI: Fix CircleCI #865 (larsoner)

## v0.10.0

In this version, the default Sphinx-Gallery .css files have been updated so their names are all prepended with ‘sg_’. For more details see #845.

Implemented enhancements:

- Generalising image_scrapers facility for non-images #833

- Add a mode that fails only for rst warnings and does not run examples #751

- Add a “template”, to make it easy to get started #555

- ENH Add config that generates dummy images to prevent missing image warnings #828 (lucyleeow)

- ENH: add hidpi option to matplotlib_scraper and directive #808 (jklymak)

Fixed bugs:

- BUG URL quote branch names and filepaths in Binder URLs #844 (sdhiscocks)

- Sanitize ANSI characters from generated reST: Remove ANSI characters from HTML output #838 (agramfort)

- Bug Pin markupsafe version in Python nightly #831 (lucyleeow)

- BUG Fix test_minigallery_directive failing on Windows #830 (lucyleeow)

- BUG Fix LaTeX Error: File `tgtermes.sty’ not found in CI #829 (lucyleeow)

Merged pull requests:

- DOC Update reset_modules documentation #861 (lucyleeow)

- Remove trailing whitespace #859 (lucyleeow)

- Add info on enabling animation support to example #858 (dstansby)

- Update css file names, fix documentation #857 (lucyleeow)

- MAINT: Fix mayavi build hang circleci #850 (lucyleeow)

- MAINT: Fix mayavi build hang azure CI #848 (lucyleeow)

- Refactor execute_code_block in gen_rst.py #842 (lucyleeow)

- [Maint] Remove travis #840 (agramfort)

- DOC Add gif to supported image extensions #836 (lucyleeow)

- DOC Clarifications and fixes to image_scrapers doc #834 (jnothman)

- DOC Update projects list in readme.rst #826 (lucyleeow)

- DOC Fix zenodo badge link #825 (lucyleeow)

- DOC Add TorchIO to users list #824 (fepegar)

## v0.9.0

Support for Python 3.5 dropped in this release. Requirement is Python >=3.6.

Implemented enhancements:

- Add a mode which “skips” an example if it fails #789

- Can sphinx_gallery_thumbnail_number support negative indexes? #785

- Configure thumbnail style #780

- ENH: Check for invalid sphinx_gallery_conf keys #774

- DOC Document how to hide download link note #760

- DOC use intersphinx references in projects_list.rst #755

- Delay output capturing to a further code block #363

- ENH: Only add minigallery if there’s something to show #813 (NicolasHug)

- Optional flag to defer figure scraping to the next code block #801 (ayshih)

- ENH: PyQt5 #794 (larsoner)

- Add a configuration to warn on error not fail #792 (Cadair)

- Let sphinx_gallery_thumbnail_number support negative indexes #786 (seisman)

- Make any borders introduced when rescaling images to thumbnails transparent #781 (rossbar)

- MAINT: Move travis CI jobs to Azure #779 (lucyleeow)

- ENH, DEP: Check for invalid keys, remove ancient key #775 (larsoner)

Fixed bugs:

- Custom CSS for space above title target conflicts with pydata-sphinx-theme #815

- Minigalleries are generated even for objects without examples #812

- Python nightly failing due to Jinja2 import from collections.abc #790

- test_rebuild and test_error_messages failing on travis #777

- Animation not show on Read the Docs #772

- BUG: Empty code block output #765

- BUG: Fix CSS selector #816 (larsoner)

- MAINT: Fix test for links #811 (larsoner)

- Fix SVG default thumbnail support #810 (jacobolofsson)

- Clarify clean docs for custom gallery_dirs #798 (timhoffm)

- MAINT Specify Jinja2 version in azure Python nightly #793 (lucyleeow)

- BUG Remove if final block empty #791 (lucyleeow)

- Replace Travis CI badge with Azure Badge in README #783 (sdhiscocks)

- Point to up-to-date re documentation #778 (dstansby)

Merged pull requests:

- DOC Add section on altering CSS #820 (lucyleeow)

- DOC Use intersphinx references in projects_list.rst #819 (lucyleeow)

- DOC Update CI badge #818 (lucyleeow)

- DOC Include SOURCEDIR in Makefile #814 (NicolasHug)

- DOC: add 2 projects using sphinx gallery #807 (mfeurer)

- DOC: clarify advanced doc wrt referencing examples #806 (mfeurer)

- MAINT: Add link #800 (larsoner)

- Add Optuna to “Who uses Optuna” #796 (crcrpar)

- DOC Add segment on CSS styling #788 (lucyleeow)

- DOC minor doc typo fixes #787 (lucyleeow)

- DOC Update CI links in index.rst #784 (lucyleeow)

## v0.8.2

Enables HTML animations to be rendered on readthedocs.

Implemented enhancements:

- DOC Expand on sphinx_gallery_thumbnail_path #764 (lucyleeow)

- ENH: Add run_stale_examples config var #759 (larsoner)

- Option to disable note in example header #757

- Add show_signature option #756 (jschueller)

- ENH: Style HTML output like jupyter #752 (larsoner)

- ENH: Add reST comments, read-only #750 (larsoner)

- Relate warnings and errors on generated rst file back to source Python file / prevent accidental writing of generated files #725

Fixed bugs:

- Example gallery is down #753

- DOC Amend run_stale_examples command in configuration.rst #763 (lucyleeow)

- DOC update link in projects_list #754 (lucyleeow)

- Enable animations HTML to be rendered on readthedocs #748 (sdhiscocks)

Merged pull requests:

- FIX: Restore whitespace #768 (larsoner)

- CI: Remove AppVeyor, work on Azure #767 (larsoner)

- DOC Standardise capitalisation of Sphinx-Gallery #762 (lucyleeow)

## v0.8.1

Fix Binder logo image file for Windows paths.

Fixed bugs:

- sphinx_gallery/tests/test_full.py::test_binder_logo_exists fails (path is clearly wrong) #746

- BUG Windows relative path error with _static Binder logo #744

- BUG Copy Binder logo to avoid Window drive rel path error #745 (lucyleeow)

Merged pull requests:

- DOC Add link to cross referencing example #743 (lucyleeow)

## v0.8.0

The default for configuration thumbnail_size will change from (400, 280) (2.5x maximum size specified by CSS) to (320, 224) (2x maximum size specified by CSS) in version 0.9.0.

Implemented enhancements:

- Pass command line arguments to examples #731

- Limited rst to md support in notebooks #219

- Enable ffmpeg for animations for newer matplotlib #733 (dopplershift)

- Implement option to pass command line args to example scripts #732 (mschmidt87)

- ENH: Dont allow input #729 (larsoner)

- Add support for image links and data URIs for notebooks #724 (sdhiscocks)

- Support headings in reST to MD #723 (sdhiscocks)

- ENH Support pypandoc to convert rst to md for ipynb #705 (lucyleeow)

- ENH: Use broader def of Animation #693 (larsoner)

Fixed bugs:

- _repr_html_ not shown on RTD #736

- Binder icon is hardcoded, which causes a loading failure with on some browsers #735

- How to scrape for images without executing example scripts #728

- sphinx-gallery/0.7.0: TypeError: ‘str’ object is not callable when building its documentation #727

- Thumbnail oversampling #717

- Working with pre-built galleries #704

- Calling “plt.show()” raises an ugly warning #694

- Searching in docs v0.6.2 stable does not work #689

- Fix logger message pypandoc #741 (lucyleeow)

- Use local binder logo svg #738 (lucyleeow)

- BUG: Fix handling of scraper error #737 (larsoner)

- Improve documentation of example for custom image scraper #730 (mschmidt87)

- Make md5 hash independent of platform line endings #722 (sdhiscocks)

- MAINT: Deal with mayavi #720 (larsoner)

- DOC Clarify thumbnail_size and note change in default #719 (lucyleeow)

- BUG: Always do linking #714 (larsoner)

- DOC: Correctly document option #711 (larsoner)

- BUG Check ‘capture_repr’ and ‘ignore_repr_types’ #709 (lucyleeow)

- DOC Update Sphinx url #708 (lucyleeow)

- BUG: Use relative paths for zip downloads #706 (pmeier)

- FIX: Build on nightly using master #703 (larsoner)

- MAINT: Fix CircleCI #701 (larsoner)

- Enable html to be rendered on readthedocs #700 (sdhiscocks)

- Remove matplotlib agg warning #696 (lucyleeow)

Merged pull requests:

- DOC add section on interpreting error/warnings #740 (lucyleeow)

- DOC Add citation details to readme #739 (lucyleeow)

- Plotly example for the gallery #718 (emmanuelle)

- DOC Specify matplotlib in animation example #716 (lucyleeow)

- MAINT: Bump pytest versions in Travis runs #712 (larsoner)

- DOC Update warning section in configuration.rst #702 (lucyleeow)

- DOC remove mention of other builder types #698 (lucyleeow)

- Bumpversion #692 (lucyleeow)

## v0.7.0

### Developer changes

- Use Sphinx errors rather than built-in errors.

Implemented enhancements:

- ENH: Use Sphinx errors #690 (larsoner)

- ENH: Add support for FuncAnimation #687 (larsoner)

- Sphinx directive to insert mini-galleries #685 (ayshih)

- Provide a Sphinx directive to insert a mini-gallery #683

- ENH Add cross ref label to template module.rst #680 (lucyleeow)

- ENH: Add show_memory extension API #677 (larsoner)

- Support for GPU memory logging #671

- ENH Add alt attribute for thumbnails #668 (lucyleeow)

- ENH More informative ‘alt’ attribute for thumbnails in index #664

- ENH More informative ‘alt’ attribute for images #663 (lucyleeow)

- ENH: Use optipng when requested #656 (larsoner)

- thumbnails cause heavy gallery pages and long loading time #655

- MAINT: Better error messages #600

- More informative “alt” attribute for image tags #538

- ENH: easy linking to “examples using my_function” #496

- sub-galleries should be generated with a separate “gallery rst” file #413

- matplotlib animations support #150

Fixed bugs:

- Add backref label for classes in module.rst #688 (lucyleeow)

- Fixed backreference inspection to account for tilde use #684 (ayshih)

- Fix regex for numpy RandomState in test_full #682 (lucyleeow)

- fix tests regex to search for numpy data in html #681

- FIX: Fix sys.stdout patching #678 (larsoner)

- check-manifest causing master to fail #675

- Output of logger is not captured if the logger is created in a different cell #672

- FIX: Remove newlines from title #669 (larsoner)

- BUG Tinybuild autosummary links fail with Sphinx dev #659

Documentation:

- DOC Update label to raw string in plot_0_sin.py #674 (lucyleeow)

- DOC Update Sphinx url to https #673 (lucyleeow)

- DOC Clarify syntax.rst #670 (lucyleeow)

- DOC Note config comment removal in code only #667 (lucyleeow)

- DOC Update links in syntax.rst #666 (lucyleeow)

- DOC Fix typos, clarify #662 (lucyleeow)

- DOC Update html-noplot #658 (lucyleeow)

- DOC: Fix PNGScraper example #653 (denkii)

- DOC: Fix typos in documentation files. #652 (TomDonoghue)

- Inconsistency with applying & removing sphinx gallery configs #665

- `make html-noplot` instructions outdated #606

Merged pull requests:

- Fix lint in gen_gallery.py #686 (lucyleeow)

- Better alt thumbnail test for punctuation in title #679 (lucyleeow)

- Update manifest for changes to check-manifest #676 (lucyleeow)

- MAINT: Update CircleCI #657 (larsoner)

- Bump version to 0.7.0.dev0 #651 (lucyleeow)

## v0.6.2

- Patch release due to missing CSS files in v0.6.1. Manifest check added to CI.

Implemented enhancements:

- How do I best cite sphinx-gallery? #639

- MRG, ENH: Add Zenodo badge #641 (larsoner)

Fixed bugs:

- BUG Wrong pandas intersphinx URL #646

- css not included in wheels? #644

- BUG: Fix CSS includes and add manifest check in CI #648 (larsoner)

- Update pandas intersphinx url #647 (lucyleeow)

Merged pull requests:

- Update maintainers url in RELEASES.md #649 (lucyleeow)

- DOC Amend maintainers #643 (lucyleeow)

- Change version back to 0.7.0.dev0 #642 (lucyleeow)

## v0.6.1

### Developer changes

- Added Zenodo integration. This release is for Zenodo to pick it up.

Implemented enhancements:

- Allow pathlib.Path to backreferences_dir option #635

- ENH Allow backrefences_dir to be pathlib object #638 (lucyleeow)

Fixed bugs:

- TypeError when creating links from gallery to documentation #634

- BUG Checks if filenames have space #636 (lucyleeow)

- Fix missing space in error message. #632 (anntzer)

- BUG: Spaces in example filenames break image linking #440

Merged pull requests:

- DOC minor update to release guide #633 (lucyleeow)

- Bump release version #631 (lucyleeow)

## v0.6.0

### Developer changes

- Reduced number of hard dependencies and added dev-requirements.txt.

- AppVeyor bumped from Python 3.6 to 3.7.

- Split CSS and create sub-extension that loads CSS.

Implemented enhancements:

- ENH Add last cell config #625 (lucyleeow)

- ENH: Add sub-classes for download links #623 (larsoner)

- ENH: New file-based conf-parameter thumbnail_path #609 (prisae)

- MRG, ENH: Provide sub-extension sphinx_gallery.load_style #601 (mgeier)

- [DOC] Minor amendments to CSS config part #594 (lucyleeow)

- [MRG] [ENH] Add css for pandas df #590 (lucyleeow)

- ENH: Add CSS classes for backrefs #581 (larsoner)

- Add ability to ignore repr of specific types #577 (banesullivan)

Fixed bugs:

- BUG: Longer timeout on macOS #629 (larsoner)

- BUG Fix test for new sphinx #619 (lucyleeow)

- MRG, FIX: Allow pickling #604 (larsoner)

- CSS: Restrict thumbnail height to 112 px #595 (mgeier)

- MRG, FIX: Link to RandomState properly #593 (larsoner)

- MRG, FIX: Fix backref styling #591 (larsoner)

- MAINT: Update checks for PIL/JPEG #586 (larsoner)

- DOC: Fix code block language #585 (larsoner)

- [MRG] Fix backreferences for functions not directly imported #584 (lucyleeow)

- BUG: Fix repr None #578 (larsoner)

- [MRG] Add ignore pattern to check dups #574 (lucyleeow)

- [MRG] Check backreferences_dir config #571 (lucyleeow)

- URLError #569 (EtienneCmb)

- MRG Remove last/first_notebook_cell redundancy #626 (lucyleeow)

- Remove duplicate doc_solver entry in the API reference structure #589 (kanderso-nrel)

Merged pull requests:

- DOC use # %% #624 (lucyleeow)

- DOC capture repr in scraper section #616 (lucyleeow)

- [MRG+1] DOC Improve doc of splitters and use in IDE #615 (lucyleeow)

- DOC mention template #613 (lucyleeow)

- recommend consistent use of one block splitter #610 (mikofski)

- MRG, MAINT: Split CSS and add control #599 (larsoner)

- MRG, MAINT: Update deps #598 (larsoner)

- MRG, ENH: Link to methods and properties properly #596 (larsoner)

- MAINT: Try to get nightly working #592 (larsoner)

- mention literalinclude in the doc #582 (emmanuelle)

- MAINT: Bump AppVeyor to 3.7 #575 (larsoner)

## v0.5.0

### Developer changes

- Separated ‘dev’ documentation, which tracks master and ‘stable’ documentation, which follows releases.

- Added official jpeg support.

### Incompatible changes

- Dropped support for Sphinx < 1.8.3.

- Dropped support for Python < 3.5.

- Added `capture_repr` configuration with the default setting `('_repr_html_', __repr__')`. This may result the capturing of unwanted output in existing projects. Set `capture_repr: ()` to return to behaviour prior to this release.

Implemented enhancements:

- Explain the inputs of the image scrapers #472

- Capture HTML output as in Jupyter #396

- Feature request: Add an option for different cell separations #370

- Mark sphinx extension as parallel-safe for writing #561 (astrofrog)

- ENH: Support linking to builtin modules #558 (larsoner)

- ENH: Add official JPG support and better tests #557 (larsoner)

- [MRG] ENH: Capture ’repr’s of last expression #541 (lucyleeow)

- look for both ‘README’ and ‘readme’ #535 (revesansparole)

- ENH: Speed up builds #526 (larsoner)

- ENH: Add live object refs and methods #525 (larsoner)

- ENH: Show memory usage, too #523 (larsoner)

- [MRG] EHN support #%% cell separators #518 (lucyleeow)

- MAINT: Remove support for old Python and Sphinx #513 (larsoner)

Fixed bugs:

- Documentation is ahead of current release #559

- Fix JPEG thumbnail generation #556 (rgov)

- [MRG] Fix terminal rst block last word #548 (lucyleeow)

- [MRG][FIX] Remove output box from print(__doc__) #529 (lucyleeow)

- BUG: Fix kwargs modification in loop #527 (larsoner)

- MAINT: Fix AppVeyor #524 (larsoner)

Merged pull requests:

- [MRG] DOC: Add warning filter note in doc #564 (lucyleeow)

- [MRG] DOC: Explain each example #563 (lucyleeow)

- ENH: Add dev/stable distinction #562 (larsoner)

- DOC update example capture_repr #552 (lucyleeow)

- BUG: Fix index check #551 (larsoner)

- FIX: Fix spurious failures #550 (larsoner)

- MAINT: Update CIs #549 (larsoner)

- list of projects using sphinx-gallery #547 (emmanuelle)

- [MRG] DOC typos and clarifications #545 (lucyleeow)

- add class to clear tag #543 (dorafc)

- MAINT: Fix for 3.8 #542 (larsoner)

- [MRG] DOC: Explain image scraper inputs #539 (lucyleeow)

- [MRG] Allow punctuation marks in title #537 (lucyleeow)

- Improve documentation #533 (lucyleeow)

- ENH: Add direct link to artifact #532 (larsoner)

- [MRG] Remove matplotlib agg backend + plt.show warnings from doc #521 (lesteve)

- MAINT: Fixes for latest pytest #516 (larsoner)

- Add FURY to the sphinx-gallery users list #515 (skoudoro)

## v0.4.0

### Developer changes

- Added a private API contract for external scrapers to have string-based support, see:

  > https://github.com/sphinx-gallery/sphinx-gallery/pull/494

- Standard error is now caught and displayed alongside standard output.

- Some sphinx markup is now removed from image thumbnail tooltips.

### Incompatible changes

- v0.4.0 will be the last release to support Python <= 3.4.

- Moving forward, we will support only the latest two stable Sphinx releases at the time of each sphinx-gallery release.

Implemented enhancements:

- ENH: Remove some Sphinx markup from text #511 (larsoner)

- ENH: Allow README.rst ext #510 (larsoner)

- binder requirements with Dockerfile? #476

- ENH: Update docs #509 (larsoner)

- Add documentation note on RTD-Binder incompatibility #505 (StanczakDominik)

- Add PlasmaPy to list of sphinx-gallery users #504 (StanczakDominik)

- ENH: Expose example globals #502 (larsoner)

- DOC: Update docs #501 (larsoner)

- add link to view sourcecode in docs #499 (sappelhoff)

- MRG, ENH: Catch and write warnings #495 (larsoner)

- MRG, ENH: Add private API for external scrapers #494 (larsoner)

- Add list of external image scrapers #492 (banesullivan)

- Add more examples of projects using sphinx-gallery #489 (banesullivan)

- Add option to remove sphinx_gallery config comments #487 (timhoffm)

- FIX: allow Dockerfile #477 (jasmainak)

- MRG: Add SVG support #471 (larsoner)

- MAINT: Simplify CircleCI build #462 (larsoner)

- Release v0.3.0 #456 (choldgraf)

- adding contributing guide for releases #455 (choldgraf)

Fixed bugs:

- fix wrong keyword in docs for “binder” #500 (sappelhoff)

- Fix ‘Out:’ label position in html output block #484 (timhoffm)

- Mention pytest-coverage dependency #482 (timhoffm)

- Fix reST block after docstring #480 (timhoffm)

- MAINT: Tolerate Windows mtime #478 (larsoner)

- FIX: Output from code execution is not stripped #475 (padix-key)

- FIX: Link #470 (larsoner)

- FIX: Minor fixes for memory profiling #468 (larsoner)

- Add output figure numbering breaking change in release notes. #466 (lesteve)

- Remove links to read the docs #461 (GaelVaroquaux)

- [MRG+1] Add requirements.txt to manifest #458 (ksunden)

## v0.3.1

Bugfix release: add missing file that prevented “pip installing” the package.

Fixed bugs:

- Version 0.3.0 release is broken on pypi #459

## v0.3.0

### Incompatible changes

- the output figure numbering is always 1, 2, …, `number_of_figures` whereas in 0.2.0 it would follow the matplotlib figure numbers. If you include explicitly some figures generated by sphinx-gallery with the `.. figure` directive in your `.rst` documentation you may need to adjust their paths if your example uses non-default matplotlib figure numbers (e.g. if you use `plt.figure(0)`). See #464 <https://github.com/sphinx-gallery/sphinx-gallery/issues/464> for more details.

### Developer changes

- Dropped support for Sphinx <= 1.4.

- Refactor for independent rst file construction. Function `sphinx_gallery.gen_rst.generate_file_rst` does not anymore compose the rst file while it is executing each block of the source code. Currently executing the example script `execute_script` is an independent function and returns structured in a list the rst representation of the output of each source block. `generate_file_rst` calls for execution of the script when needed, then from the rst output it composes an rst document which includes the prose, code & output of the example which is the directly saved to file including the annotations of binder badges, download buttons and timing statistics.

- Binder link config changes. The configuration value for the BinderHub has been changed from `url` to `binderhub_url` in order to make it more explicit. The old configuration key (`url`) will be deprecated in version v0.4.0)

- Support for generating JUnit XML summary files via the `'junit'` configuration value, which can be useful for building on CI services such as CircleCI. See the related CircleCI doc and blog post.

Fixed bugs:

- First gallery plot uses .matplotlibrc rather than the matplotlib defaults #316

Merged pull requests:

- [MRG+1]: Output JUnit XML file #454 (larsoner)

- MRG: Use highlight_language #453 (larsoner)

- BUG: Fix execution time writing #451 (larsoner)

- MRG: Adjust lineno for 3.8 #450 (larsoner)

- MRG: Only rebuild necessary parts #448 (larsoner)

- MAINT: Drop 3.4, add mayavi to one #447 (larsoner)

- MAINT: Modernize requirements #445 (larsoner)

- Activating travis on pre-release of python #443 (NelleV)

- [MRG] updating binder instructions #439 (choldgraf)

- FIX: Fix for latest sphinx-dev #437 (larsoner)

- adding notes for filename #436 (choldgraf)

- FIX: correct sorting docstring for the FileNameSortKey class #433 (mrakitin)

- MRG: Fix for latest pytest #432 (larsoner)

- FIX: Bump version #431 (larsoner)

- MRG: Fix for newer sphinx #430 (larsoner)

- DOC: Missing perenthisis in PNGScraper #428 (ksunden)

- Fix #425 #426 (Titan-C)

- Scraper documentation and an image file path scraper #417 (choldgraf)

- MRG: Remove outdated cron job #416 (larsoner)

- ENH: Profile memory #415 (larsoner)

- fix typo #414 (zasdfgbnm)

- FIX: Travis #410 (larsoner)

- documentation index page and getting_started updates #403 (choldgraf)

- adding ability to customize first cell of notebooks #401 (choldgraf)

- spelling fix #398 (amueller)

- [MRG] Fix Circle v2 #393 (lesteve)

- MRG: Move to CircleCI V2 #392 (larsoner)

- MRG: Fix for 1.8.0 dev #391 (larsoner)

- Drop “Total running time” when generating the documentation #390 (lamby)

- Add dedicated class for timing related block #359 (ThomasG77)

- MRG: Add timing information #348 (larsoner)

- MRG: Add refs from docstring to backrefs #347 (larsoner)

- API: Refactor image scraping #313 (larsoner)

- [MRG] FIX import local modules in examples #305 (NelleV)

- [MRG] Separate rst notebook generation from execution of the script #239 (Titan-C)

## v0.2.0

### New features

- Added experimental support to auto-generate Binder links for examples via `binder` config. Note that this API may change in the future. #244 and #371.

- Added `ignore_pattern` configurable to allow not adding some python files into the gallery. See #346 for more details.

- Support for custom default thumbnails in ‘RGBA’ space #375

- Allow title only -> use title as first paragraph #345

### Bug Fixes

- Fix name string_replace trips on projects with “.py” in path. See #322 and #331 for more details.

- Fix __future__ imports across cells. See #308 for more details.

- Fix encoding related issues when locale is not UTF-8. See #311 for more details.

- In verbose mode, example output is printed to the console during execution of the example, rather than only at the end. See #301 for a use case where it matters.

- Fix SphinxDocLinkResolver error with sphinx 1.7. See #352 for more details.

- Fix unexpected interaction between `file_pattern` and `expected_failing_examples`. See #379 and #335

- FIX: Use unstyled pygments for output #384

- Fix: Gallery name for paths ending with ‘/’ #372

- Fix title detection logic. #356

- FIX: Use `docutils_namespace` to avoid warning in sphinx 1.8dev #387

### Incompatible Changes

- Removed optipng feature that was triggered when the `SKLEARN_DOC_OPTIPNG` variable was set. See #349 for more details.

- `Backreferences_dir` is now mandatory #307

### Developer changes

- Dropped support for Sphinx <= 1.4.

- Add SphinxAppWrapper class in `test_gen_gallery.py` #386

- Notes on how to do a release #360

- Add codecov support #328

## v0.1.13

### New features

- Added `min_reported_time` configurable. For examples that run faster than that threshold (in seconds), the execution time is not reported.

- Add thumbnail_size option #283

- Use intersphinx for all function reference resolution #296

- Sphinx only directive for downloads #298

- Allow sorting subsection files #281

- We recommend using a string for `plot_gallery` rather than Python booleans, e.g. `'True'` instead of `True`, as it avoids a warning about unicode when controlling this value via the command line switches of `sphinx-build`

### Bug Fixes

- Crasher in doc_resolv, in js_index.loads #287

- Fix gzip/BytesIO error #293

- Deactivate virtualenv provided by Travis #294

### Developer changes

- Push the docs from Circle CI into github #268

- Report version to sphinx. #292

- Minor changes to log format. #285 and #291

## v0.1.12

### New features

- Implement a explicit order sortkey to specify the subsection’s order within a gallery. Refer to discussion in #37, #233 and #234

- Cleanup console output during build #250

- New configuration Test #225

### Bug Fixes

- Reset `sys.argv` before running each example. See #252 for more details.

- Correctly re-raise errors in doc resolver. See #264.

- Allow and use https links where possible #258.

- Escape tooltips for any HTML special characters. #249

### Documentation

- Update link to numpy to point to latest #271

- Added documentation dependencies. #267

## v0.1.11

### Documentation

- Frequently Asked Questions added to Documentation. Why __file__ is not defined?

### Bug Fixed

- Changed attribute name of Sphinx app object in #242

## v0.1.10

### Bug Fixed

- Fix image path handling bug introduced in #218

## v0.1.9

### Incompatible Changes

- Sphinx Gallery’s example back-references are deactivated by default. Now it is users responsibility to turn them on and set the directory where to store the files. See discussion in #126 and pull request #151.

### Bug Fixed

- Fix download zip files path in windows builds. See #218

- Fix embedded missing link. See #214

### Developer changes

- Move testing to py.test

- Include link to github repository in documentation

## v0.1.8

### New features

- Drop styling in codelinks tooltip. Replaced for title attribute which is managed by the browser.

- Gallery output is shorter when embedding links

- Circle CI testing

### Bug Fixes

- Sphinx-Gallery build even if examples have Syntax errors. See #177

- Sphinx-Gallery can now build by directly calling sphinx-build from any path, no explicit need to run the Makefile from the sources directory. See #190 for more details.

## v0.1.7

### Bug Fixes

- Released Sphinx 1.5 has new naming convention for auto generated files and breaks Sphinx-Gallery documentation scanner. Fixed in #178, work for linking to documentation generated with Sphinx<1.5 and for new docs post 1.5

- Code links tooltip are now left aligned with code

### New features

- Development support of Sphinx-Gallery on Windows #179 & #182

## v0.1.6

### New features

- Executable script to convert Python scripts into Jupyter Notebooks #148

### Bug Fixes

- Sphinx-Gallery now raises an exception if the matplotlib backend can not be set to `'agg'`. This can happen for example if matplotlib.pyplot is imported in conf.py. See #157 for more details.

- Fix `backreferences.identify_names` when module is used without attribute #173. Closes #172 and #149

- Raise FileNotFoundError when README.txt is not present in the main directory of the examples gallery(#164). Also include extra empty lines after reading README.txt to obtain the correct rendering of the html file.(#165)

- Ship a License file in PyPI release

## v0.1.5

### New features

- CSS. Now a tooltip is displayed on the source code blocks to make the doc-resolv functionality more discorverable. Function calls in the source code blocks are hyperlinks to their online documentation.

- Download buttons have a nicer look across all themes offered by Sphinx

### Developer changes

- Support on the fly theme change for local builds of the Sphinx-Gallery docs. Passing to the make target the variable theme builds the docs with the new theme. All sphinx themes are available plus read the docs online theme under the value rtd as shown in this usage example.

      $ make html theme=rtd

- Test Sphinx Gallery support on Ubuntu 14 packages, drop Ubuntu 12 support. Drop support for Python 2.6 in the conda environment

## v0.1.4

### New features

- Enhanced CSS for download buttons

- Download buttons at the end of the gallery to download all python scripts or Jupyter notebooks together in a zip file. New config variable download_all_examples to toggle this effect. Activated by default

- Downloadable zip file with all examples as Python scripts and notebooks for each gallery

- Improved conversion of rst directives to markdown for the Jupyter notebook text blocks

### Bug Fixes

- When seaborn is imported in a example the plot style preferences are transferred to plots executed afterwards. The CI is set up such that users can follow how to get the compatible versions of mayavi-pandas-seaborn and nomkl in a conda environment to have all the features available.

- Fix math conversion from example rst to Jupyter notebook text for inline math and multi-line equations

## v0.1.3

### New features

- Summary of failing examples with traceback at the end of the sphinx build. By default the build exits with a 1 exit code if an example has failed. A list of examples that are expected to fail can be defined in conf.py and exit the build with 0 exit code. Alternatively it is possible to exit the build as soon as one example has failed.

- Print aggregated and sorted list of computation times of all examples in the console during the build.

- For examples that create multiple figures, set the thumbnail image.

- The `plot_gallery` and `abort_on_example_error` options can now be specified in `sphinx_gallery_conf`. The build option (`-D` flag passed to `sphinx-build`) takes precedence over the `sphinx_gallery_conf` option.

### Bug Fixes

- Failing examples are retried on every build

## v0.1.2

### Bug Fixes

- Examples that use `if __name__ == '__main__'` guards are now run

- Added vertical space between code output and code source in non notebook examples

## v0.1.1

### Bug Fixes

- Restore the html-noplot functionality

- Gallery CSS now implicitly enforces thumbnails width

## v0.1.0

### Highlights

Example scripts are now available for download as IPython Notebooks #75

### New features

- Configurable filename pattern to select which example scripts are executed while building the Gallery

- Examples script update check are now by md5sum check and not date

- Broken Examples now display a Broken thumbnail in the gallery view, inside the rendered example traceback is printed. User can also set build process to abort as soon as an example fails.

- Sorting examples by script size

- Improve examples style

## v0.0.11

### Highlights

This release incorporates the Notebook styled examples for the gallery with PR #36

### Incompatible Changes

Sphinx-Gallery renames its python module name to sphinx_gallery this follows the discussion raised in #47 and resolved with #66

The gallery configuration dictionary also changes its name to `sphinx_gallery_conf`

From PR #36 it is decided into a new namespace convention for images, thumbnails and references. See comment

## v0.0.10

### Highlights

This release allows to use the Back references. This features incorporates fine grained examples galleries listing examples using a particular function. #26

### New features

- Shell script to place a local copy of Sphinx-Gallery in your project

- Support Mayavi plots in the gallery